/***************************************************************************
                          ksoundsysview.h  -  description
                             -------------------
    begin                : Sun Dec 26 01:22:14 CET 1999
    copyright            : (C) 1999 by Tobias Wollgam
    email                : Tobias.Wollgam@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSOUNDSYSVIEW_H
#define KSOUNDSYSVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>


#include "ksoundwidgetpro.h"

class KSoundSysDoc;

/** The KSoundSysView class provides the view widget for the KSoundSysApp instance.	
	* The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KSoundSysView is part of the
	* docuement-view model, it needs a reference to the document object connected with it by the KSoundSysApp class to manipulate and display
	* the document structure provided by the KSoundSysDoc class.
 	* 	
 	* @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
	* @version KDevelop version 0.4 code generation
 	*/
class KSoundSysView : public KSoundWidgetPro
{
  Q_OBJECT

public:
  /** Constructor for the main view */
  KSoundSysView(QWidget* parent, const char* name, CSample *sample);
  /** Destructor for the main view */
  ~KSoundSysView();

	/** returns a pointer to the document connected to the view instance. Mind that this method requires a KSoundSysApp instance as a parent
		* widget to get to the window document pointer by calling the KSoundSysApp::getDocument() method.
		*
		* @see KSoundSysApp#getDocument
		*/
	KSoundSysDoc* getDocument() const;
	
  /** contains the implementation for printing functionality */
	void print(QPrinter* m_pPrinter);
		
public slots: // Public slots
  /**  */
  void slotUpdate();


};

#endif // KSOUNDSYSVIEW_H































